<template>
  <!-- Контейнер представления -->
  <el-container>
    <transition name="el-zoom-in-center">
      <el-main v-show="isShow" style="display: flex; flex-direction: column">
        <!-- Компонент поиска медиапланов и загрузки TVR -->
        <el-row type="flex" justify="space-between" style="flex-wrap: wrap">
          <el-col :xs="24" :md="6" style="margin-bottom: 2%">
            <el-card shadow="hover">
              <!-- Заголовок карточки поиска медиапланов -->
              <div slot="header" class="clearfix">
                <span class="card-header-title">Поиск медиапланов</span>
              </div>
              <!-- Компонент выбора направления продаж -->
              <ComponentSelectSellingDirection :event-bus="eventBus" />
              <!-- Компонент выбора каналов -->
              <ComponentSelectChannel
                :event-bus="eventBus"
                :isMultiple="true"
              />
              <!-- Компонент выбора рекламодателей -->
              <ComponentSelectAdvertiser :event-bus="eventBus" />
              <!-- Компонент выбора периода -->
              <ComponentSelectMonthRange :event-bus="eventBus" />
            </el-card>
          </el-col>
          <!-- Компонент загрузки TVR -->
          <ComponentUploadTVR :event-bus="eventBus" />
        </el-row>
        <!-- Таблица медиапланов -->
        <el-row style="flex: 1">
          <MediaPlansCollectionComponent :event-bus="eventBus" />
        </el-row>
      </el-main>
    </transition>
  </el-container>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import ComponentUploadTVR from "@/components/search-media-plan-view/ComponentUploadTVR.vue";
import ComponentSelectChannel from "@/components/common/ComponentSelectChannel.vue";
import ComponentSelectSellingDirection from "@/components/common/ComponentSelectSellingDirection.vue";
import ComponentSelectAdvertiser from "@/components/search-media-plan-view/ComponentSelectAdvertiser.vue";
import ComponentSelectMonthRange from "@/components/search-media-plan-view/ComponentSelectMonthRange.vue";
import MediaPlansCollectionComponent from "@/components/search-media-plan-view/MediaPlansCollectionComponent.vue";
import { MediaPlan } from "@/interfaces/MediaPlan";

/**
 * Представление поиска медиапланов.
 */
@Component({
  components: {
    ComponentUploadTVR,
    ComponentSelectMonthRange,
    ComponentSelectChannel,
    ComponentSelectAdvertiser,
    ComponentSelectSellingDirection,
    MediaPlansCollectionComponent,
  },
})
export default class ViewMediaPlanSearch extends Vue {
  /**
   * Автобус событий.
   * Главная сущость представления и дочерних компонентов этого представления.
   * Является тунелем, по которому общаются и передают данные между собой дочерние компоненты и представление.
   */
  private eventBus: Vue = new Vue();

  /**
   * Требуется для отыгровки анимации.
   * Признак "отображать скрытые по умолчанию элементы".
   */
  private isShow = false;

  /**
   * Метод срабатывает после создания представления.
   */
  protected created(): void {
    // Подписываемся на событие перехода в параметры выбранного медиаплана
    this.eventBus.$on(
      "selected-media-plan-parameters",
      this.goToMediaPlanParameters
    );
  }

  /**
   * Метод срабатывает после инициализации представления.
   */
  protected mounted(): void {
    // Отображаем элементы представления после небольшой задержки, чтобы
    // воспроизвелась анимация
    setTimeout(() => (this.isShow = true), 200);
  }

  /**
   * Метод срабатывает перед уничтожением представления.
   */
  protected beforeDestroy(): void {
    // Отписываемся от события перехода в параметры выбранного медиаплана
    this.eventBus?.$off(
      "selected-media-plan-parameters",
      this.goToMediaPlanParameters
    );
    // Уничтожаем экземпляр Vue, который является "автобусом событий"
    this.eventBus?.$destroy();
  }

  /**
   * Метод инициализации перехода в представление параметров медиаплана для автоматического размещения.
   * @param {MediaPlan} mediaPlan медиаплан, который был выбран.
   */
  private goToMediaPlanParameters(mediaPlan: MediaPlan): void {
    // Скрываем элементы представления, чтобы воспроизвелась анимация
    this.isShow = false;
    // Даём анимации воспроизвестись после смены флага и меняем представление
    setTimeout(() => {
      this.$router.push({
        name: "ViewMediaPlanParameters",
        params: { id: mediaPlan.id.toString() },
      });
    }, 200);
  }
}
</script>

<style lang="scss" scoped>
// Скрываем ползунок прокрутки в представлении
.el-main::-webkit-scrollbar {
  display: none;
}

.el-container {
  padding: 2%;
  height: 100%;
}
.el-row {
  .el-col {
    .el-card {
      height: 100%;
      .el-card__header {
        height: 65px;
        min-height: 65px;
      }
    }
  }
}
</style>
